apiVersion: cert-manager.io/v1
kind: Certificate
metadata:
  name: ui-cert
  namespace: {{.Release.Namespace}}
spec:
  isCA: false
  commonName: ui*
  dnsNames:
    - "ui"
    - "ui*"
  secretName: ui-cert-secret
  privateKey:
    algorithm: ECDSA
    size: 256
  issuerRef:
    name: lamassu-ca-issuer
    kind: Issuer
    group: cert-manager.io
---
apiVersion: apps/v1
kind: Deployment
metadata:  
  name: ui-deployment
  namespace: {{.Release.Namespace}}
  labels:
    app: ui
spec:
  replicas: 1
  selector:
    matchLabels:
      app: ui
  template:
    metadata:
      labels:
        app: ui
    spec:     
      containers:
        - name: lamassu-ui
          image: {{.Values.image.ui}}
          env:
            - name: DOMAIN
              value: {{.Values.domain}}
            - name: REACT_APP_AUTH_ENDPOINT
              value: "https://auth.{{.Values.domain}}/auth"
            - name: REACT_APP_AUTH_REALM
              value: "lamassu"
            - name: REACT_APP_AUTH_CLIENT_ID
              value: "frontend"
            - name: REACT_APP_LAMASSU_CLOUD_PROXY_API
              value: "https://{{.Values.domain}}/api/cloudproxy"
            - name: REACT_APP_LAMASSU_CA_API
              value: "https://{{.Values.domain}}/api/ca"
            - name: REACT_APP_LAMASSU_DMS_ENROLLER_API
              value: "https://{{.Values.domain}}/api/dmsenroller"
            - name: REACT_APP_LAMASSU_DEVMANAGER
              value: "https://{{.Values.domain}}/api/devmanager"
          volumeMounts:
            - name: ui-tls-certificates
              mountPath: /certs/tls.crt
              subPath: tls.crt
            - name: ui-tls-certificates
              mountPath: /certs/tls.key
              subPath: tls.key
          ports:
            - containerPort: 443
      restartPolicy: Always
      volumes:
        - name: ui-tls-certificates
          secret:
            secretName: ui-cert-secret
---
apiVersion: v1
kind: Service
metadata:
  name: ui
  namespace: {{.Release.Namespace}}
spec:
  selector:
    app: ui
  type: ClusterIP
  ports:
  - name: https
    port: 443
    targetPort: 443
    protocol: TCP
# ---
# apiVersion: networking.k8s.io/v1
# kind: Ingress
# metadata:
#   name: ui-ingress
#   namespace: {{.Release.Namespace}}
#   annotations: 
#     cert-manager.io/issuer: "lamassu-ca-issuer"
#     kubernetes.io/ingress.class: "nginx"
#     nginx.ingress.kubernetes.io/backend-protocol: "HTTPS"
# spec:
#   tls:
#   - hosts:
#     - {{.Values.domain}}
#     secretName: downstream-crt-secret
#   rules:
#   - host: {{.Values.domain}}
#     http: 
#       paths:
#       - pathType: Prefix
#         path: /
#         backend: 
#           service: 
#             name: "ui"
#             port:
#               number: 443